#include "TCPTestPluginNode.h"

TCPTestPluginNode::TCPTestPluginNode() : rvs::CommandServerNode("TCPTestPluginNode")
{
    RegisterCommands({"ROBOT_TCP", "ROBOT_JOINTS", "MOVE_TCP"}); // 0 ,1 ,2
    RegisterOutput("Pose", "tcp_pose");                          // 3
    RegisterOutput("JointArray", "robot_joints");                // 4
    RegisterInput("Pose", "tcp_pose");                           // 3
    RVS_PLUGIN_NODE_LOG(warning, "tcp test server init success", "tcp test server 初始化成功");
}

TCPTestPluginNode::~TCPTestPluginNode()
{
}

bool TCPTestPluginNode::ReceivedCommand(const std::string &command, const std::string &message)
{
    if (command == "ROBOT_TCP")
    {
        //
        RVS_PLUGIN_NODE_LOG(info, "Rec > tcp_pose", "Rec > tcp_pose");
        Pose *tcp_pose = GetPoseOutput(3);
        if (tcp_pose->FromString(message))
        {
            RVS_PLUGIN_NODE_LOG(info, "Rec > ROBOT_TCP : " << *tcp_pose, "Rec > ROBOT_TCP : " << *tcp_pose);
            return true;
        }
        return false;
    }
    else if (command == "ROBOT_JOINTS")
    {
        RVS_PLUGIN_NODE_LOG(info, "Rec > robot_joints", "Rec > robot_joints");
        JointArray *tcp_joints = GetJointArrayOutput(4);
        if (tcp_joints->FromString(message))
        {
            RVS_PLUGIN_NODE_LOG(info, "Rec > ROBOT_JOINTS : " << *tcp_joints, "Rec > ROBOT_JOINTS : " << *tcp_joints);
            return true;
        }
        return false;
    }
    else if (command == "MOVE_TCP")
    {
        RVS_PLUGIN_NODE_LOG(info, "Rec > MOVE_TCP ", "Rec > MOVE_TCP ");
        return true;
    }
    else
        return false;
}

std::string TCPTestPluginNode::AcknowledgeCommand(const std::string &command)
{
    std::string ack_str;
    if (command == "ROBOT_TCP")
    {
        ack_str = "ROBOT_TCP";
        std::cout << "Ack > " << ack_str << std::endl;
        return ack_str;
    }
    else if (command == "ROBOT_JOINTS")
    {
        ack_str = "ROBOT_JOINTS";
        std::cout << "Ack > " << ack_str << std::endl;
        return ack_str;
    }
    else if (command == "MOVE_TCP")
    {
        ack_str = "MOVE_TCP";
        const Pose *to_tcp = GetPoseInput(3);
        ack_str += to_tcp->PoseToStr();
        std::cout << "Ack > " << ack_str << std::endl;
        return ack_str;
    }
    else
        return "";
}