#include <iostream>
#include "rvs_kernel/rvsPluginClass.h"
// #include "rvs_plugin/rvsLogging.h"
#include "rvs_plugin/rvsLoggingCN.h"
/*
 *以下为要添加的头文件
 */
#include "SimpleSortPluginNode.h"
#include "TCPTestPluginNode.h"
#include "MatchTemplateThreadPluginNode.h"
// ===== Factory Function - Plugin EntryPoint ==== //

RVS_PLUGIN_EXPORT_C
auto GetPluginFactory() -> rvsPluginBase *
{
  static rvsPluginFactory pinfo = []
  {
    auto p = rvsPluginFactory("rvsPluginRVSProgramming", "rvs-1.0.5");
    /*
     * 请根据下面的示例进行修改
     * 在此处注册相应的Node
     */
    p.RegisterNode<SimpleSortPluginNode>("SimpleSortPluginNode");
    p.RegisterNode<TCPTestPluginNode>("TCPTestPluginNode");
    p.RegisterNode<MatchTemplateThreadPluginNode>("MatchTemplateThreadPluginNode");
    return p;
  }();
  return &pinfo;
}

struct _DLLInit
{
  _DLLInit()
  {
    RVS_PLUGIN_NODE_LOG(info, "Shared library rvsPluginRVSProgramming loaded OK.", "Shared library rvsPluginRVSProgramming loaded OK.");
  }
  ~_DLLInit()
  {
    RVS_PLUGIN_NODE_LOG(info, "Shared library rvsPluginRVSProgramming unloaded OK.", "Shared library rvsPluginRVSProgramming unloaded OK.");
  }
} dll_init;
